(function($){
	var hasNative = Modernizr.audio && Modernizr.video;
	var hasSwf;
	var mediaelement = {};
	
	var anchor = document.createElement('a');
	var getSrc = function(href){
		if(href == null){return '';}
		anchor.setAttribute('href', href+'' );
		return !$.support.hrefNormalized ? anchor.getAttribute('href', 4) : anchor.href;
	};
	var getSrcObj = function(elem, nodeName){
		elem = $(elem);
		var src = {src: elem.attr('src') || '', elem: elem};
		if(!src.src){return src;}
		src.srcProp = getSrc(src.src);
		var tmp = elem.attr('type');
		if(tmp){
			src.type = tmp;
			src.container = $.trim(tmp.split(';')[0]);
		} else {
			if(!nodeName){
				nodeName = elem[0].nodeName.toLowerCase();
				if(nodeName == 'source'){
					nodeName = (elem.closest('video, audio')[0] || {nodeName: 'video'}).nodeName.toLowerCase();
				}
			}
			tmp = mediaelement.getTypeForSrc(src.src, nodeName );
			
			if(tmp){
				src.type = tmp;
				src.container = tmp;
				if($.nodeName(elem[0], 'source')){
					elem.attr('type', tmp);
				}
			}
		}
		tmp = elem.attr('media');
		if(tmp){
			src.media = tmp;
		}
		return src;
	};
	
mediaelement.mimeTypes = {
	audio: {
			//ogm shouldn´t be used!
			'audio/ogg': ['ogg','oga', 'ogm'],
			'audio/mpeg': ['mp2','mp3','mpga','mpega'],
			'audio/mp4': ['mp4','mpg4', 'm4r', 'm4a', 'm4p', 'm4b', 'aac'],
			'audio/wav': ['wav'],
			'audio/3gpp': ['3gp','3gpp'],
			'audio/webm': ['webm'],
			'audio/fla': ['flv', 'f4a', 'fla'],
			'application/x-mpegURL': ['m3u8', 'm3u']
		},
		video: {
			//ogm shouldn´t be used!
			'video/ogg': ['ogg','ogv', 'ogm'],
			'video/mpeg': ['mpg','mpeg','mpe'],
			'video/mp4': ['mp4','mpg4', 'm4v'],
			'video/quicktime': ['mov','qt'],
			'video/x-msvideo': ['avi'],
			'video/x-ms-asf': ['asf', 'asx'],
			'video/flv': ['flv', 'f4v'],
			'video/3gpp': ['3gp','3gpp'],
			'video/webm': ['webm'],
			'application/x-mpegURL': ['m3u8', 'm3u'],
			'video/MP2T': ['ts']
		}
	}
;
	
	mediaelement.mimeTypes.source =  $.extend({}, mediaelement.mimeTypes.audio, mediaelement.mimeTypes.video);
	
	mediaelement.getTypeForSrc = function(src, nodeName){
		if(src.indexOf('youtube.com/watch?') != -1){
			return 'video/youtube';
		}
		src = src.split('?')[0].split('.');
		src = src[src.length - 1];
		var mt;
		
		$.each(mediaelement.mimeTypes[nodeName], function(mimeType, exts){
			if(exts.indexOf(src) !== -1){
				mt = mimeType;
				return false;
			}
		});
		return mt;
	};
	
	
	mediaelement.srces = function(mediaElem){
		mediaElem = $(mediaElem);
		
		var srces = [];
		var nodeName = mediaElem[0].nodeName.toLowerCase();
		var src = getSrcObj(mediaElem, nodeName);
		
		if(!src.src){
			$('source', mediaElem).each(function(){
				src = getSrcObj(this, nodeName);
				if(src.src){srces.push(src);}
			});
		} else {
			srces.push(src);
		}
		return srces;
	};
	
	mediaelement.swfMimeTypes = ['video/3gpp', 'video/x-msvideo', 'video/quicktime', 'video/x-m4v', 'video/mp4', 'video/m4p', 'video/x-flv', 'video/flv', 'audio/mpeg', 'audio/aac', 'audio/mp4', 'audio/x-m4a', 'audio/m4a', 'audio/mp3', 'audio/x-fla', 'audio/fla', 'youtube/flv', 'jwplayer/jwplayer', 'video/youtube'];
	
	mediaelement.canSwfPlaySrces = function(mediaElem, srces){
		var ret = '';
		mediaElem = $(mediaElem);
		srces = srces || mediaelement.srces(mediaElem);
		$.each(srces, function(i, src){
			if(src.container && src.src && mediaelement.swfMimeTypes.indexOf(src.container) != -1){
				ret = src;
				return false;
			}
		});
		return ret;
	};
	mediaelement.canNativePlaySrces = function(mediaElem, srces){
		var ret = '';
		if(hasNative){
			mediaElem = $(mediaElem);
			srces = srces || mediaelement.srces(mediaElem);
			
			$.each(srces, function(i, src){
				if(src.type && mediaElem[0].canPlayType && mediaElem[0].canPlayType(src.type) ){
					ret = src;
					return false;
				}
			});
		}
		return ret;
	};
	
	var id = new Date().getTime();
	var embedSwf = function(elem, srces, opts){
		id++;
		var src = mediaelement.canSwfPlaySrces(elem, srces);
		if(!src){return;}
		var width = $(elem).width();
		var height = $(elem).height();
		var playerID = 'flowplayer-'+ id;
		var nodeName = elem.nodeName.toLowerCase();
		var config = [];
		var poster = $(elem).attr('poster');
		var videoReplace = $('<div id="'+ playerID +'"></div>').css({width: width, height: height}).insertBefore(elem);
		$(elem).hide();
		
		if(poster){
			config.push( "'"+getSrc(poster)+"'" );
		}
		config.push("{'url': '"+src.srcProp+"', 'autoPlay': false}");
		
		swfobject.embedSWF(opts.path + opts.playerName, playerID, width, height, "9.0.0", null, 
			{ 
				config: "{'plugins': {'controls': {'url': '"+opts.controlsName+"'} }, 'playlist': ["+config.join(',')+"]}"
			},
			{
				wmode: "transparent",
				allowfullscreen: "true"
			},
			{
				style: "width: "+width +"px; height: "+ height +"px;"
			}
		); 
	};
	
	
	$.fn.media2Flowplayer = function(opts){
		
		if(hasSwf == null){
			hasSwf = !window.swfobject || swfobject.hasFlashPlayerVersion('9.0.0');
		}
		
		opts = $.extend({}, $.fn.media2Flowplayer.defaults, opts);
		
		if(!hasSwf){
			opts.preferFlash = false;
		}
		return this.each(function(){
			var srces = mediaelement.srces(this);
			if(srces && srces.length && (!mediaelement.canNativePlaySrces(this, srces) || (opts.preferFlash && mediaelement.canSwfPlaySrces(this, srces)))){
				embedSwf(this, srces, opts);
			}
		});
	};
	
	$.fn.media2Flowplayer.defaults = {
		path: "js/mediaplayer/",
		playerName: "flowplayer-3.2.7.swf",
		controlsName: "flowplayer.controls-3-2-5.swf",
		preferFlash: false
		
	};
	
})(jQuery);